@echo off
:##############################################################################
:#                                                                            #
:#                                                                            #
:#                                                                            #
:#                                                                            #
:#                                                                            #
:#                                                                            #
:#                                                                            #
:#		                                                              #
:#                                                                            #
:#                                                                            #
:#		                                                              #
:#                                                                            #
:#                                                                            #
:#                                                                            #
:#                                                                            #
:#                                                                            #
:#		    There are TABs on this line				      #
:#                                                                            #
:#                                                                            #
:#                                                                            #
:#                                                                            #
:#                                                                            #
:#                                                                            #
:#                                                                            #
:#                                                                            #
:#		                                                              #
:#                                                                            #
:#		                                                              #
:#		                                                              #
:#   2019-02-06 JFL The problem appeared with this cmt.			      #
:#		                                                              #
:#                                                                            #
:#                                                                            #
:##############################################################################

setlocal EnableExtensions EnableDelayedExpansion
set "VERSION=2019-02-06"
set "SCRIPT=%~nx0"				&:# Script name
set "SPATH=%~dp0" & set "SPATH=!SPATH:~0,-1!"	&:# Script path, without the trailing \
set "SFULL=%~f0"				&:# Script full pathname
set ^"ARG0=%0^"					&:# Script invokation name
set ^"ARGS=%*^"					&:# Argument line
goto :main

:#----------------------------------------------------------------------------#
:# make sure a directory is in the PATH
:PutInPath %1=directory that should be in the PATH
setlocal EnableExtensions EnableDelayedExpansion
if not "!PATH:~0,1!"==";" set "PATH=;!PATH!"
if not "!PATH:~-1!"==";" set "PATH=!PATH!;"
if "!PATH:;%~1;=;!"=="!PATH!" set "PATH=!PATH!%~1;"
set "PATH=!PATH:~1,-1!" &:# Trim the extra ; added above
endlocal & set "PATH=%PATH%" & exit /b

:#----------------------------------------------------------------------------#
:# Check if the user has system administrator rights. %ERRORLEVEL% 0=Yes; 5=No
:IsAdmin
>NUL 2>&1 "%SYSTEMROOT%\system32\cacls.exe" "%SYSTEMROOT%\system32\config\system"
exit /b

:#----------------------------------------------------------------------------#
:# Extract the ARG0 and ARG1 from %CMDCMDLINE% using cmd.exe own parser
:SplitArgs
set "ARG0=%1"
set "ARG1=%2"
:#----------------------------------------------------------------------------#
:# Installation routine
:install
setlocal EnableExtensions EnableDelayedExpansion

:# Check prerequisites
if /i "%PROCESSOR_ARCHITECTURE%" neq "x86" if /i "%PROCESSOR_ARCHITECTURE%" neq "AMD64" (
  if not "%FORCE%"=="1" (
    >&2 echo Error: This script does not support the %PROCESSOR_ARCHITECTURE% processor architecture
    exit /b 1
  )
)

:# Create the extension directories
for %%h in (HKLM HKCU) do (
  if not exist "!AUTORUN.D[%%h]!" %EXEC% md "!AUTORUN.D[%%h]!"
)

:# Test if there are previously installed AutoRun scripts
for %%h in (HKLM HKCU) do (
  call :query %%h AutoRun
  if defined AutoRun (
    if not "%SFULL%"=="!AutoRun!" (
      if not "%FORCE%"=="1" (
	>&2 echo Error: Another AutoRun script is already installed for !USER[%%h]!: !AutoRun!
	endlocal & exit /b 1
      )
      :# In force mode, move the previous autorun to AutoRun.cmd.d
      %ECHO.COMMENT% Moving the existing AutoRun script !AutoRun! to !AUTORUN.D[%%h]!
      %EXEC% move "!AutoRun!" "!AUTORUN.D[%%h]!"
      :# Also delete its key, else the next call to :query will display an error
      set "KEY=%%h\Software\Microsoft\Command Processor"
      %ECHO.COMMENT% Deleting "!KEY!\AutoRun"
      %EXEC% reg delete "!KEY!" /v "AutoRun" /f
    ) else (
      %ECHO.COMMENT% Already installed
      endlocal & exit /b 0
    )
  )
)
:# OK, no previous instance installed. Try installing ourselves
if not defined HIVE (
  call :IsAdmin
  if not errorlevel 1 (	:# Admin user. Install for all users.
    set "HIVE=HKLM"
  ) else (		:# Normal user. Install for himself.
    set "HIVE=HKCU"
  )
)
set "KEY=%HIVE%\Software\Microsoft\Command Processor"
%ECHO.COMMENT% Creating registry key "%KEY%" value "AutoRun"
%EXEC% reg add "%KEY%" /v "AutoRun" /t REG_SZ /d "%SFULL%" /f

endlocal & exit /b

:#----------------------------------------------------------------------------#
:# Uninstallation routine
:uninstall
setlocal EnableExtensions EnableDelayedExpansion
set "HIVES=%HIVE%"
if not defined HIVES set "HIVES=HKLM HKCU"
:# Test if there are previously installed AutoRun scripts
for %%h in (%HIVES%) do (
  call :query %%h AutoRun
  if defined AutoRun (
    if not "%SFULL%"=="!AutoRun!" if not "%FORCE%"=="1" (
      >&2 echo Error: Another AutoRun script is installed for !USER[%%h]!: "!AutoRun!"
      endlocal & exit /b 1
    )
    set "KEY=%%h\Software\Microsoft\Command Processor"
    %ECHO.COMMENT% Deleting regisry key "!KEY!" value "AutoRun"
    %EXEC% reg delete "!KEY!" /v "AutoRun" /f
  )
)
endlocal & exit /b

:#----------------------------------------------------------------------------#
:# Installation test routine
:query %1=Hive %2=OutputVarName
setlocal EnableExtensions EnableDelayedExpansion
set "KEY=%1\Software\Microsoft\Command Processor"
for /f "tokens=2,3*" %%a in ('reg query "!KEY!" /v AutoRun 2^>NUL ^| findstr AutoRun') do (
  set "TYPE=%%a"
  set "VALUE=%%b"
  if "%~2"=="" echo !USER[%1]!: !VALUE!
  if "!TYPE!"=="REG_EXPAND_SZ" call set "VALUE=!VALUE!"
)
endlocal & (if not "%~2"=="" (set "%~2=%VALUE%")) & exit /b

:#----------------------------------------------------------------------------#
:# Installation enumeration routine
:list
setlocal EnableExtensions EnableDelayedExpansion
:# First display the AutoRun scripts configured
%ECHO.COMMENT% AutoRun scripts:
@echo on
for %%h in (HKLM HKCU) do call :query %%h
:# Then display available extension scripts
%ECHO.COMMENT%.
%ECHO.COMMENT% Extension scripts:
for %%h in (HKLM HKCU) do if exist "!AUTORUN.D[%%h]!" (
  for %%b in ("!AUTORUN.D[%%h]!\*.bat" "!AUTORUN.D[%%h]!\*.cmd") do (
    echo !USER[%%h]!: %%~b
  )
)
endlocal & exit /b

:#----------------------------------------------------------------------------#
:# Main routine
:main
set "ECHO.COMMENT=echo"
set "DEBUG.LOG=rem"
set "DEBUG.LOG=if exist "%TEMP%\AutoRun.log" >>"%TEMP%\AutoRun.log" echo"
set "EXEC="
set "ACTION=list"
set "AUTORUN.D[HKLM]=%ALLUSERSPROFILE%\AutoRun.cmd.d"
set "AUTORUN.D[HKCU]=%USERPROFILE%\AutoRun.cmd.d"
set "USER[HKLM]=all users"
set "USER[HKCU]=%USERNAME%"
goto :list
